typo in backupninja.1
[matthijs/upstream/backupninja.git] / handlers / pgsql
index 3f7d0b9ac943e38b5f5c82f5318156c44b0420ab..23e2c2b42f0553864846b1fba38c91d5d4469e1f 100644 (file)
@@ -1,3 +1,4 @@
+# -*- mode: sh; sh-basic-offset: 3; indent-tabs-mode: nil; -*-
 #
 # PostgreSQL handler script for backupninja
 #
@@ -9,46 +10,48 @@ getconf vsname
 
 localhost=`hostname`
 
-# If vservers are configured, decide if the handler should
-# use them or if it should just operate on the host
-if [ "$vservers" == "yes" ]; then
-    if [ ! -z $vsname ]; then          
-       info "using vserver '$vsname'"
-       usevserver=1
-    else
-       info "no vserver name specified, actions will be performed on the host"
-    fi
+# Decide if the handler should operate on a vserver or on the host.
+# In the former case, check that $vsname exists and is running.
+local usevserver=no
+local vroot
+if [ $vservers_are_available = yes ]; then
+   if [ -n "$vsname" ]; then
+      # does it exist ?
+      if ! vservers_exist "$vsname" ; then
+         fatal "The vserver given in vsname ($vsname) does not exist."
+      fi
+      # is it running ?
+      $VSERVERINFO -q $vsname RUNNING
+      if [ $? -ne 0 ]; then
+         fatal "The vserver $vsname is not running."
+      fi
+      # everything ok
+      info "Using vserver '$vsname'."
+      usevserver=yes
+      vroot="$VROOTDIR/$vsname"
+   else
+      info "No vserver name specified, actions will be performed on the host."
+   fi
 fi
 
-# As needed, make sure that :
-#   * the specified vserver exists and is running
-#   * the specified vserver or host has the needed executables
-if [ $usevserver ]; then
-    info "examining vserver '$vsname'"
-    # does it exist ?
-    vroot="$VROOTDIR/$vsname"
-    [ -d $vroot ] || fatal "vserver '$vsname' does not exist at '$vroot'"
-    # is it running ?
-    running=`$VSERVERINFO $vsname RUNNING`
-    if [ $running = 1 ]; then
-       if [ "$databases" == "all" ]; then
-           [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMPALL`" ] || \
-               fatal "Can't find $PGSQLDUMPALL in vserver $vsname."
-       else
-           [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMP`" ] || \
-               fatal "Can't find $PGSQLDUMP in vserver $vsname."
-       fi
-    else
-       fatal "vserver $vsname is not running."
-    fi
+# Make sure that the system to backup has the needed executables
+if [ $usevserver = yes ]; then
+   debug "Examining vserver '$vsname'."
+   if [ "$databases" == "all" ]; then
+      [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMPALL`" ] || \
+        fatal "Can't find $PGSQLDUMPALL in vserver $vsname."
+   else
+      [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMP`" ] || \
+        fatal "Can't find $PGSQLDUMP in vserver $vsname."
+   fi
 else
-    if [ "$databases" == "all" ]; then
-       [ -x "`which $PGSQLDUMPALL`" ] || \
-           fatal "Can't find $PGSQLDUMPALL."
-    else
-       [ -x "`which $PGSQLDUMP`" ] || \
-           fatal "Can't find $PGSQLDUMP."
-    fi
+   if [ "$databases" == "all" ]; then
+      [ -x "`which $PGSQLDUMPALL`" ] || \
+        fatal "Can't find $PGSQLDUMPALL."
+   else
+      [ -x "`which $PGSQLDUMP`" ] || \
+        fatal "Can't find $PGSQLDUMP."
+   fi
 fi
 
 # create backup dir, the vroot variable will be empty if no vsname was specified
@@ -57,10 +60,14 @@ fi
 [ -d $vroot$backupdir ] || fatal "Backup directory '$vroot$backupdir'"
 
 # give backup dir the good uid and permissions
-# (in respect to the vserver, if $usevserver)
-pguid=`grep '^postgres:' $vroot/etc/passwd | awk -F: '{print $3}'`
+# (in respect to the vserver, if $usevserver = yes)
+if [ $usevserver = yes ]; then
+   pguid=`$VSERVER $vsname exec getent passwd $PGSQLUSER | @AWK@ -F: '{print $3}'`
+else
+   pguid=`getent passwd $PGSQLUSER | @AWK@ -F: '{print $3}'`
+fi
 [ -n "$pguid" ] || \
-    fatal "No user called postgres`[ $usevserver != 1 ] || echo \" on vserver $vsname\"`."
+    fatal "No user called $PGSQLUSER`[ $usevserver = no ] || echo \" on vserver $vsname\"`."
 debug "chown $pguid $vroot$backupdir"
 chown $pguid $vroot$backupdir
 debug "chmod 700 $vroot$backupdir"
@@ -68,15 +75,23 @@ chmod 700 $vroot$backupdir
 
 # if $databases = all, use pg_dumpall
 if [ "$databases" == "all" ]; then
-    if [ $usevserver ]; then
-       execstr="$VSERVER $vsname exec su - postgres -c $PGSQLDUMPALL > $vroot$backupdir/${vsname}.sql"
+    if [ $usevserver = yes ]; then
+       if [ "$compress" == "yes" ]; then          
+          execstr="$VSERVER $vsname exec su - $PGSQLUSER -c \"$PGSQLDUMPALL | $GZIP > $backupdir/${vsname}.sql.gz\""
+       else
+          execstr="$VSERVER $vsname exec su - $PGSQLUSER -c \"$PGSQLDUMPALL > $backupdir/${vsname}.sql\""
+       fi
     else
-       execstr="su - postgres -c $PGSQLDUMPALL > $backupdir/${localhost}-all.sql"
+       if [ "$compress" == "yes" ]; then
+          execstr="su - $PGSQLUSER -c \"$PGSQLDUMPALL | $GZIP > $backupdir/${localhost}-all.sql.gz\""
+       else
+       execstr="su - $PGSQLUSER -c \"$PGSQLDUMPALL > $backupdir/${localhost}-all.sql\""
+       fi
     fi
     debug "$execstr"
     if [ ! $test ]; then
-       output=`$execstr 2>&1`
-       code=$?
+       output=`eval $execstr 2>&1`
+       code=$?
        if [ "$code" == "0" ]; then
            debug $output
            info "Successfully finished dump of pgsql cluster"
@@ -89,15 +104,22 @@ if [ "$databases" == "all" ]; then
 # else use pg_dump on each specified database
 else
     for db in $databases; do
-       if [ $usevserver ]
-           then
-           execstr="$VSERVER $vsname exec su - postgres -c $PGSQLDUMP $db > $vroot$backupdir/${db}.sql"
+       if [ $usevserver = yes ]; then
+           if [ "$compress" == "yes" ]; then
+              execstr="$VSERVER $vsname exec su - $PGSQLUSER -c \"$PGSQLDUMP $db | $GZIP > $backupdir/${db}.sql.gz\""
+           else
+              execstr="$VSERVER $vsname exec su - $PGSQLUSER -c \"$PGSQLDUMP $db | > $backupdir/${db}.sql\""
+           fi
        else
-           execstr="su - postgres -c $PGSQLDUMP $db > $backupdir/${db}.sql"
+           if [ "$compress" == "yes" ]; then
+              execstr="su - $PGSQLUSER -c \"$PGSQLDUMP $db | $GZIP > $backupdir/${db}.sql.gz\""
+           else
+              execstr="su - $PGSQLUSER -c \"$PGSQLDUMP $db > $backupdir/${db}.sql\""
+           fi
        fi
        debug "$execstr"
        if [ ! $test ]; then
-           output=`$execstr 2>&1`
+           output=`eval $execstr 2>&1`
            code=$?
            if [ "$code" == "0" ]; then
                debug $output
@@ -110,10 +132,5 @@ else
     done
 fi
 
-if [ "$compress" == "yes" ]; then
-    output=`$GZIP -f $vroot$backupdir/*.sql 2>&1`
-    debug $output
-fi
-
 return 0